var subTools = {
    toast: function(msg) {
        api.toast({
            title: "提示",
            msg: msg,
            duration: 2000,
            location: 'middle'
        });
    },
    checkUserId: function(source) {
        if (source == 'report') {
            url = 'win_commonRedBar.html';
        } else {
            url = '../win_commonRedBar.html'
        }
        var userEntity = sessionAgent.getLoginInfo();
        var userId = userEntity.userId;
        if (userId != null && userId != "") {
            return true;
        } else {
            api.openWin({
                name: 'login',
                url: url,
                pageParam: {
                    bannerTitle: '登录',
                    hidEditBtn: 'hidden',
                    childHtmlUrl: 'frm_login.html'
                }
            });
            return false
        }
    },
    imageCache: function(url) {
        var path = url;
        api.imageCache({
            url: url
        }, function(ret, err) {
            if (ret) {
                path = ret.url;
            }
        });
        return path;
    },
    isEmpty: function(val) {
        if (null == val || "" == val) {
            return true;
        }
        return false;
    },
    openCollect: function() {
        api.openWin({
            name: "win_collectList",
            url: 'jph_header2.html',
            pageParam: {
                bannerTitle: '我的收藏',
                childName: 'frm_collectList',
                childHtmlUrl: 'jph_collectList.html',
                hidEditBtn: 'hidden',
            }
        });
        hideBlack(); //使用该方法的页面必须包含此方法
    },
    dateDiff: function(hisTime, nowTime) {
        var now = nowTime ? nowTime : new Date().getTime(),
            diffValue = now - hisTime,
            result = '',
            minute = 1000 * 60,
            hour = minute * 60,
            day = hour * 24,
            halfamonth = day * 15,
            month = day * 30,
            year = month * 12,

            _year = diffValue / year,
            _month = diffValue / month,
            _week = diffValue / (7 * day),
            _day = diffValue / day,
            _hour = diffValue / hour,
            _min = diffValue / minute;

        if (_day >= 1) result = new Date(hisTime).format("yyyy-MM-dd");
        else if (_hour >= 1) result = parseInt(_hour) + "个小时前";
        else if (_min >= 1) result = parseInt(_min) + "分钟前";
        else result = "刚刚";
        return result;
    },
    dateFormat: function(val, time) {
        var result = new Date(time).format(val);
        return result;
    },
    toastNetErr: function(errCode) {
        var errMsg = '网络连接异常，请稍后再试';

        if (errCode != null && errCode != "") {
            errMsg += '(' + errCode + ')';
        }
        api.toast({
            msg: errMsg,
            duration: 2000,
            location: 'middle'
        });
    },
};

var subAjax = {
    truthUrl: "http://app.jiupaicn.com", //真相URL
  //  serverUrl: "http://jphceshi.jiupaicn.com", //线上测试，
//serverUrl:"http://192.168.100.78:8081",   /*  李明电脑*/
 serverUrl: "http://appjph.jiupaicn.com", //上线的时候地址 （正式域名）    九派号域名，funcTools.js里面也有serverUrlJava，注意其中 userVisitFunc 的地址要修改
adUrl: "http://b.eqxiu.com/s/dkl3k9mE?from=sqq&eqrcode=1"
}

Date.prototype.format = function(fmt) { //author: meizz
    var o = {
        "M+": this.getMonth() + 1, //月份
        "d+": this.getDate(), //日
        "h+": this.getHours(), //小时
        "m+": this.getMinutes(), //分
        "s+": this.getSeconds(), //秒
        "q+": Math.floor((this.getMonth() + 3) / 3), //季度
        "S": this.getMilliseconds() //毫秒
    };
    if (/(y+)/.test(fmt))
        fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (var k in o)
        if (new RegExp("(" + k + ")").test(fmt))
            fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    return fmt;
}

function fixIos7Bar(el) {
    var isAndroid = (/android/gi).test(navigator.appVersion);
    var strSV = api.systemVersion;
    var numSV = parseInt(strSV, 10);
    var strDM = api.systemType;
    if (!isAndroid && numSV >= 7) {
        el.css("padding-top", "20px")
    }
}
