(function(window){
	function uzStorage(){
    	var isAndroid = (/android/gi).test(navigator.appVersion);
        var ls = window.localStorage;
        if(isAndroid){
           ls = os.localStorage();
        }
        return ls;
	}

	var sessionAgent= {
		keyMap:{
			collectNews : 'collectNewsMap', //新闻收藏列表
			userAuthInfo: 'userAuth', //用户权限信息
			userReadHistory: 'readHisIds', //用户阅读历史
			bookedUserIds: 'bookedUserIds',  //当前订阅用户列表
			usrCollCates: 'usrCollCates', //用户收藏的频道栏目
			goodInfoIdList: 'goodInfoIdList', //用户点赞的文章列表
			ifSendTheDeviceInfo: 'ifSendTheDeviceInfo', //是否发送过设备信息
			statServToken: 'statServToken', //统计平台的token
			cloudPushId: 'cloudPushId', //云推送的注册id
			indexFramePageName: 'indexFramePageName', //首页列表样式
			systemSetKey: 'systemSetKey', //系统参数设置
			commentGoodId: 'commentGoodId', //回复点赞id
			adImgEntry: 'adImgEntry', //保存广告图片数据对象
			isFirstLoad: 'isFirstLoad', //是否是首次启动app
			columnRedaHis: 'columnRedaHis', //栏目新闻阅读历史
			offlineCateList: 'offlineCateList' //已缓存频道列表
		},
		
	    setStorage: function(key, value){
	        if(arguments.length === 2){
	            var v = value;
	            if(typeof v == 'object'){
	                v = JSON.stringify(v);
	                v = 'obj-'+ v;
	            }else{
	                v = 'str-'+ v;
	            }
	            var ls = uzStorage();
	            if(ls){
	                ls.setItem(key, v);
	            }
	        }
	    },
	    getStorage: function(key){
	        var ls = uzStorage();
	        if(ls){
	            var v = ls.getItem(key);
	            if(!v){return;}
	            if(v.indexOf('obj-') === 0){
	                v = v.slice(4);
	                return JSON.parse(v);
	            }else if(v.indexOf('str-') === 0){
	                return v.slice(4);
	            }
	        }
	    },
	    rmStorage: function(key){
	        var ls = uzStorage();
	        if(ls && key){
	            ls.removeItem(key);
	        }
	    },
	    clearStorage: function(){
	        var ls = uzStorage();
	        if(ls){
	            ls.clear();
	        }
	    }
	}

	window.sessionAgent = sessionAgent;
})(window);