var doc= '';
apiready= function(){
	api.showProgress({modal:false});
	doc= new Vue({
		el: 'body',
		data: {
			newsList: [],
			checkCateList: [],
			fileRegName: {
				baseName: 'fs://jiupai-cache/',
				shortList: 'shortList.json'
			}
		},
		computed:{},
		methods: {
			initCateList: function(selCateList){
				if(selCateList){
					var savedCateList= sessionAgent.getStorage(sessionAgent.keyMap.offlineCateList);
					var selList= [];
					var trueCateList = []; //去掉其中的九派号，视频，图集栏目
					
					for(var i=0,len=selCateList.length; i<len; i++){
						if(selCateList[i].type != 'both' && selCateList[i].type != 'jph' && selCateList[i].type != 'jpnews'){
							continue;
						}
						trueCateList.push(selCateList[i]);
						if(savedCateList && savedCateList['channel-'+ selCateList[i].cateId]){
							selCateList[i].isSaved= true;
							selList.push(selCateList[i].type+'.'+selCateList[i].cateId+'.'+selCateList[i].cateName);
							selCateList[i].updateTime= utilsFuncs.dateDiff( savedCateList['channel-'+ selCateList[i].cateId].updateTime);
						}else{
//							selCateList[i].isChecked= true;
							selCateList[i].isSaved= false;selCateList[i].updateTime='';
						}
					}
					this.checkCateList= selList;
					this.newsList= trueCateList;
					api.hideProgress();
				}
			},
			refreshNewsList: function(){
				var savedCateList= sessionAgent.getStorage(sessionAgent.keyMap.offlineCateList),
					selCateList= this.newsList;
				
				for(var i=0,len=selCateList.length; i<len; i++){
					if(savedCateList && savedCateList['channel-'+ selCateList[i].cateId]){
						selCateList[i].isSaved= true;
						selCateList[i].updateTime= utilsFuncs.dateDiff( savedCateList['channel-'+ selCateList[i].cateId].updateTime);
					}else{
						selCateList[i].isSaved= false;
					}
				}
			},
			startDownload: function(){
				var checkList= this.$get('checkCateList');
				if(checkList.length==0){
					api.toast({
	                    msg:'请选中要下载的栏目',
	                    duration: 1500,
	                    location: 'middle'
                    });
                    return ;
				}

				var effFunc= function(cList){
					api.openFrame({
		                name: 'frm-download-progress',
		                url: '../frm_offLineDlPrgs.html',
				        rect: {x: 0, y: 0, w: 'auto', h: 'auto'},
				        bgColor: 'rgba(51,51,51,0.7)',
		                pageParam: {
		                	checkCates: cList.join(",")
		                }
	                });
				}

				var connType= api.connectionType;
				if(connType=='none'){
					api.toast({
	                    msg:'当前无网络，没法下载哦!',
	                    duration: 2000,
    					location: 'middle'
                    });
					return ;
				}else if(connType!='wifi'){
					api.confirm({
						msg: '当前不是wifi网络，离线下载需要消耗很多流量，是否继续呢？',
						buttons: ['继续下载', '取消']
                    },function(ret,err){
                    	if(2==ret.buttonIndex){
                    		return ;
                    	}else{
                    		effFunc(checkList);
                    	}
                    });
				}else{
					effFunc(checkList);
				}
			},
			viewShortList: function(item, e){
				var clkTagName= e.srcElement.tagName;
				if(item.isSaved && clkTagName.toLocaleLowerCase()!='input'){
					api.openWin({
	                    name: 'offline-read-shortList-win',
	                    url: '../win_offLineRead.html',
	                    pageParam: {
							childHtmlName:'offline-read-list-frm',
							childHtmlUrl: 'frm_offLineShortList.html',
							bannerTitle: '离线阅读 - 栏目快读',
							cateId: item.cateId
						}
                    });
				}
			},
			clearFiles: function(){
				api.showProgress({modal:false});
				var fs = api.require('fs'),
					filePath= this.fileRegName.baseName,
					refFunc= this.refreshNewsList;

				fs.remove({
				    path: filePath
				},function(ret, err){
				    if(ret.status){
						api.toast({
	                        msg: '清除缓存完成',
	                        duration: 2000,
	                        location: 'middle'
                        });
				        sessionAgent.rmStorage(sessionAgent.keyMap.offlineCateList);
				    }else{
				        api.toast({
	                        msg: err.msg,
	                        duration: 2000,
	                        location: 'middle'
                        });
				    }
				    refFunc();
				    api.hideProgress();
				});
			},
			delBtnClk: function(){
				var delFunc= this.clearFiles;
				api.confirm({
//				    title: 'testtitle',
				    msg: '是否要 删除 所有离线文章？',
				    buttons: ['删除', '取消']
				},function( ret, err ){
				    if(ret && ret.buttonIndex==1){
				        delFunc();
				    }
				});				
			}
		},
		compiled: function(){
			var selectList = sessionAgent.getStorage(sessionAgent.keyMap.usrCollCates);
			if(selectList){
				this.initCateList(selectList);
			}else{
				loadCateList();
			}
		}
	});
}
function loadCateList(){
	var userEntity = sessionAgent.getStorage( sessionAgent.keyMap.userAuthInfo),
		userId = userEntity? utilsFuncs.trimStr(userEntity.userId ): '',
		actionUrl = ajaxAgent.serverAction;

	if(''==userId){
		userId = -1;
	}
	actionUrl += '&m=content&c=wap&a=keepcates&json[secCode]=&json[usrId]='+ utilsFuncs.trimStr(userId );
	api.ajax({
	    url: actionUrl,
	    method: 'get',
	    timeout: 30,
	    dataType: 'json',
	    returnAll: false,
	},function(ret,err){
	    if(ret){
			doc.initCateList(ret.selectCategorys);
			sessionAgent.setStorage(sessionAgent.keyMap.usrCollCates, ret.selectCategorys);
	    }else {
			utilsFuncs.toastNetErr();
			api.hideProgress();
	    }
	});
}