var sessionAgent = {
	timeMap:{	//退出App的时候要清楚所有缓存时间
		loginTime:'loginTime',
		channelTime:'channelTime',
		channelName:'channelName',		//这个只存字符串，其他存数组
		infoTime:'infoTime'
	},

	keyMap:{
		collectNews : 'collectNewsMap', //新闻收藏列表
		userAuthInfo: 'userAuth', //用户权限信息
		userReadHistory: 'readHisIds', //用户阅读历史
		bookedUserIds: 'bookedUserIds',  //当前订阅用户列表
		usrCollCates: 'usrCollCates', //用户收藏的频道栏目
		usrCancelCates: 'usrCancelCates', //用户未收藏的频道栏目
		userCollCateToken: 'userCollCateToken', //用户收藏栏目标识
		goodInfoIdList: 'goodInfoIdList', //用户点赞的文章列表
		ifSendTheDeviceInfo: 'ifSendTheDeviceInfo', //是否发送过设备信息
		statServToken: 'statServToken', //统计平台的token
		cloudPushId: 'cloudPushId', //云推送的注册id
		indexFramePageName: 'indexFramePageName', //首页列表样式
		systemSetKey: 'systemSetKey', //系统参数设置
		commentGoodId: 'commentGoodId', //回复点赞id
		adImgEntry: 'adImgEntry', //保存广告图片数据对象
		isFirstLoad: 'isFirstLoad', //是否是首次启动app
		columnRedaHis: 'columnRedaHis', //栏目新闻阅读历史
		subscibeReadHis: 'subscibeReadHis',  //订阅号最后阅读时间
		mainFrameIndex: 'mainFrameIndex', //最好阅读的框架编号
		commContent: 'commContent', //最新一次的评论缓存
		redPassport: 'redPassport',//红色电子护照缓存
		navigatorMap: 'navigatorMap',//本地地图程序数组
		userArea: 'userArea',//用户区域
		menu : 'menu',//菜单
		searchHis:'searchHis',
		showStep1: 'showStep1',//显示导览图，只显示一次
		showStep2: 'showStep2',//显示导览图，只显示一次
		infoEntityCache: 'infoEntityCache',//新闻信息缓存
		userReadEntitiy: 'userReadEntitiy',//用户阅读历史
		leaveTime:'leaveTime',		//第三版埋點
		IP:'IP',//迎来存取手机的ip地址
		frameList:'frameList',//数组；mainHeader.js 文件中 打开frameGroup,每次打开一个frame页时将它记录下来
		beginPicInfo:'beginPicInfo', //数组 ：起始页图片存放以及图片的版本。如：[1,url0,url1,url2,url3]。第一个位置为版本号，后面都是图片
		sessionTime:'sessionTime',  //设置 infoEntityCache 缓存时间，用于判断是否大于24小时，大于则清理首页缓存infoEntityCache,
		noInstrestData:'noInstrestData',//用户感兴趣文章
		isReadProtocol:'isReadProtocol',//是否查看协议
	},

	setLoginInfo : function(userEntity){
		sessionAgent.setStorage(sessionAgent.keyMap.userAuthInfo, userEntity);

		api.setPrefs({ key: 'userId', value: userEntity.userId });
		api.setPrefs({ key: 'userCellPhone', value: userEntity.cellPhone });
		api.setPrefs({ key: 'userNickName', value: userEntity.nickName });
	},

	getLoginInfo : function(){
		var userEntity = sessionAgent.getStorage(sessionAgent.keyMap.userAuthInfo);
		if(null==userEntity || ""==userEntity){
			userEntity= {};
		}
		return userEntity;
	},

	clearLoginInfo: function(){
		$api.rmStorage( sessionAgent.keyMap.userAuthInfo);

		api.removePrefs({ key: 'userId'});
		api.removePrefs({ key: 'userCellPhone'});
		api.removePrefs({ key: 'userNickName'});
	},

	setPrefInfo : function(infoKey, val){
		api.setPrefs({ key: infoKey, value: val });
	},

	getPrefInfo: function(infoKey){

		var returnStr;

		api.getPrefs({
	        key: infoKey
        },function(ret,err){
        	returnStr = ret.value;
        });

		return returnStr;
	},

	setStorage: function(key, obj){
		if(!!$api){
			$api.rmStorage( key)
			$api.setStorage(key, obj);
		}
	},

	rmStorage: function(key){
		if(!!$api){
			$api.rmStorage( key)
		}
	},

	getStorage: function(key){
		if(!!$api){
			return $api.getStorage(key);
		}else{
			return null;
		}
	},

	checkUserId: function(){
    	var userEntity = sessionAgent.getLoginInfo();
		var userId = userEntity.userId;
		if(userId != null && userId != ""){
			api.pageParam.userId = userId;
			return true;
        }else{
	    	api.openWin({
	            name: 'login',
	            url: 'win_commonRedBar.html',
	            pageParam:{
	            	bannerTitle: '登录',
	            	hidEditBtn: 'hidden',
	            	childHtmlUrl: 'frm_login.html'
				}
	        });
	        return false
        }
    }
}
